//size of the transposition table
/*
1048576 = 2_20
524288 = 2_19
262144 = 2_18
131072 = 2_17
*/
#define TT_Size 1048576


//size of the array of the moves available in the current position
//137 is the total maximal number of moves
#define MoveHistorySize 137


//alpha-beta treshold
#define AB_Bound 550


//transposition table entry structure
struct TranspositionTable 
	{		
			//PrimaryHashKey
		int PHK,
			//SecondaryHashKey
			SHK;
			
			//Search depth of the score
		int Depth, 
			//Score
			Value;
	};


//structure of move characteristics
struct aMove
{
	int fromSquare,
		toSquare,
		Type,
		AttackStatus,
		Score;
};


///////////////////////////////////////////
//see Global.cpp for the explanations on extern variables
///////////////////////////////////////////
extern __int64 
			   Squares[64],
			   BitBoards[14];

extern __int64 KingMovesBB[64],
			   KnightMovesBB[64],
			   RookMovesBB[64],
			   BishopMovesBB[64];

extern int KingMoves[64][8],
		   KnightMoves[64][8],
		   RookMoves[64][4][7],
		   BishopMoves[64][4][7];

extern bool WhiteLongCastling,
			WhiteShortCastling,
		    BlackLongCastling,
			BlackShortCastling,
		   
			WhiteCastlingDone,
			BlackCastlingDone;
		   
extern int MoveType,
		   EnPassant;

extern int _50MovesDraw;

extern int MovingSide;

extern int Chromosome[26];

extern TranspositionTable TransTable[TT_Size];

extern aMove MoveList[MoveHistorySize];

extern aMove GoodMoves[5],
			 BadMoves[5];

extern int PositionCounter;
